CF 181 div2 C. Beautiful Numbers

2023-12-07 05:33
文章标签 cf numbers div2 beautiful 181

本文主要是介绍CF 181 div2 C. Beautiful Numbers,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目:C - Beautiful Numbers

题意:输入a,b,n,求满足长度为n且只由a,b组成的数字各位之和也只由a,b组成的组合数。

n的大小是10^6,受之前某个题的影响,这样想的:假设a<b,最少情况是n*a,最大的情况是n*b,搜一遍判一下,然后对于可行的解用扩展欧几里得求出满足条件的a,b的个数,然后求组合数。。。这个思路也行吧,时间用得比较多,但毕竟是自己想的,赶脚还是很不错的,做题就是要大胆。


#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstring>
using namespace std;
#define maxn 1000010
typedef long long LL;
const long long  mod =1000000007;
long long fac[maxn];
long long a,b,n;
void init()
{fac[0]=1;for(int i=1;i<maxn;i++)fac[i]=(fac[i-1]*i)%mod;
}
long long exgcd(long long a,long long b,long long &x,long long &y)
{if(b==0){x=1;y=0;return a;}else{long long ans=exgcd(b,a%b,x,y);long long t=x;x=y;y=t-a/b*x;return ans;}
}
bool is_ok(long long x)
{long long tmp=x;while(tmp){if(tmp%10!=a && tmp%10!=b)return false;tmp/=10;}return true;}
long long Pow(long long a,long long b)
{long long ans=1;while(b){if(b&1){b--;ans=(ans*a)%mod;}else{b/=2;a=(a*a)%mod;}}return ans;
}long long C(LL n,LL m)
{if(n<m)return 0;LL ans=fac[n]*Pow(fac[m]*fac[n-m]%mod,mod-2)%mod;return ans%mod;
}
long long gcd(long long a,long long b)
{if(b==0)return a;return gcd(b,a%b);
}
long long solve(long long c)
{long long x,y;long long aa=a,bb=b,g=gcd(a,b);if(c%g!=0)return 0;c/=g;aa/=g;bb/=g;exgcd(aa,bb,x,y);x*=c;x%=bb;if(x<0)x+=bb;y=(c-aa*x)/bb;while(x<=n || y>=0){if(x+y==n){return C(n,x);}x+=bb;y=(c-aa*x)/bb;}return 0;
}
int main()
{init();cin>>a>>b>>n;if(a>b)swap(a,b);long long ans=0;for(int i=a*n;i<=b*n;i++)if(is_ok(i)){if(i%gcd(a,b)==0){ans+=solve(i);ans%=mod;}}cout<<ans<<endl;return 0;
}


看了别人的代码,发现我想复杂了,别人是对n位进行分配,组成后的数字的各位之和是不是还是由那两个数字组成的,这样暴力的过程,就遍历组合(0,n)(1,n-1)到(n,0)吧,确实比我简单,= = 貌似我是进行了一个逆过程,还装逼用了扩展欧几里得,呵呵。。。

还好弄出来了,不然对不起这个900+人过的 combinatorics 了。(这题应该没有人跟我一样傻逼的用上面的方法做了吧。。。)


估计大部分人都是用下面这种方法过的吧:


#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstring>
using namespace std;
#define maxn 1000010
typedef long long LL;
const long long  mod =1000000007;
long long fac[maxn];
long long a,b,n;
void init()
{fac[0]=1;for(int i=1;i<maxn;i++)fac[i]=(fac[i-1]*i)%mod;
}
bool is_ok(long long x)
{long long tmp=x;while(tmp){if(tmp%10!=a && tmp%10!=b)return false;tmp/=10;}return true;}
long long Pow(long long a,long long b)
{long long ans=1;while(b){if(b&1){b--;ans=(ans*a)%mod;}else{b/=2;a=(a*a)%mod;}}return ans;
}long long C(LL n,LL m)
{if(n<m)return 0;LL ans=fac[n]*Pow(fac[m]*fac[n-m]%mod,mod-2)%mod;return ans;
}
int main()
{init();cin>>a>>b>>n;long long ans=0;for(int i=0;i<=n;i++)if(is_ok(a*i+b*(n-i))){ans=(ans+C(n,i))%mod;}cout<<ans<<endl;return 0;
}





这篇关于CF 181 div2 C. Beautiful Numbers的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/464665

相关文章

cf 164 C 费用流

给你n个任务,k个机器,n个任务的起始时间,持续时间,完成任务的获利 每个机器可以完成任何一项任务,但是同一时刻只能完成一项任务,一旦某台机器在完成某项任务时,直到任务结束,这台机器都不能去做其他任务 最后问你当获利最大时,应该安排那些机器工作,即输出方案 具体建图方法: 新建源汇S T‘ 对任务按照起始时间s按升序排序 拆点: u 向 u'连一条边 容量为 1 费用为 -c,

CF 508C

点击打开链接 import java.util.Arrays;import java.util.Scanner;public class Main {public static void main(String [] args){new Solve().run() ;} }class Solve{int bit[] = new int[608] ;int l

计蒜客 Half-consecutive Numbers 暴力打表找规律

The numbers 11, 33, 66, 1010, 1515, 2121, 2828, 3636, 4545 and t_i=\frac{1}{2}i(i+1)t​i​​=​2​​1​​i(i+1), are called half-consecutive. For given NN, find the smallest rr which is no smaller than NN

高精度打表-Factoring Large Numbers

求斐波那契数,不打表的话会超时,打表的话普通的高精度开不出来那么大的数组,不如一个int存8位,特殊处理一下,具体看代码 #include<stdio.h>#include<string.h>#define MAX_SIZE 5005#define LEN 150#define to 100000000/*一个int存8位*/int num[MAX_SIZE][LEN];void

【CF】C. Glass Carving(二分 + 树状数组 + 优先队列 + 数组计数)

这题简直蛋疼死。。。。。 A了一下午 #include<cstdio>#include<queue>#include<cstring>#include<algorithm>using namespace std;typedef long long LL;const int maxn = 200005;int h,w,n;int C1[maxn],C2[maxn];int

【CF】E. Anya and Cubes(双向DFS)

根据题意的话每次递归分3种情况 一共最多25个数,时间复杂度为3^25,太大了 我们可以分2次求解第一次求一半的结果,也就是25/2 = 12,记录结果 之后利用剩余的一半求结果 s-结果 = 之前记录过的结果 就可以 时间复杂度降低为 3 ^ (n/2+1) 题目链接:http://codeforces.com/contest/525/problem/E #include<set

【CF】D. Arthur and Walls(BFS + 贪心)

D题 解题思路就是每次检查2X2的方格里是否只有一个‘*’,如果有的话这个*就需要变成‘.’,利用BFS进行遍历,入队的要求是这个点为. 一开始将所有的'.'全部加入队列,如果碰到一个'*'变成'.'就入队,判断的时候从4个方向就行判断 题目链接:http://codeforces.com/contest/525/problem/D #include<cstdio>#include<

leetcode#628. Maximum Product of Three Numbers

题目 Given an integer array, find three numbers whose product is maximum and output the maximum product. Example 1: Input: [1,2,3]Output: 6 Example 2: Input: [1,2,3,4]Output: 24 Note: The lengt

leetCode#448. Find All Numbers Disappeared in an Array

Description Given an array of integers where 1 ≤ a[i] ≤ n (n = size of array), some elements appear twice and others appear once. Find all the elements of [1, n] inclusive that do not appear in this

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s